<!DOCDATE html>
  <html lang="en">

  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 50.10</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>

  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="index3.html" class="nav-link">Home</a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
            style="opacity: .8">
          <span class="brand-text font-weight-light">Task 50.10</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
            </div>
            <div class="info">
              <a href="#" class="d-block">Cuong Trinh</a>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Quản lý Contacts - Food Ordering
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
              </li>

            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1>Task 50.10 - Quản lý Contacts - Food Ordering</h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">Task50.10</li>
                </ol>
              </div>
            </div>
          </div><!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <section class="content">

          <!-- Vùng header-->
          <div class="container">
            <div class="text-center mt-3">
              <h2>Quản trị Contact</h2>
            </div>
            <div class="form-group">
              <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; New User</button>
            </div>
          </div>
          <!--User Data Table-->
          <div class="container">
            <table class="table table-bordered table-striped table-hover" id="user-table">
              <thead>
                <tr>
                  <th>ID</th>
                  <th>Name</th>
                  <th>Email</th>
                  <th>Message</th>
                  <th>Ngày tạo</th>
                  <th>Action</th>
                </tr>
              </thead>
            </table>
          </div>
          <!--Vùng Modal-->

          <!--Create User modal-->
          <div>
            <div id="create-user-modal" class="modal fade" tabindex="-1">
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Create new contact</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                    <form>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-create-firstname">Name</label>
                        </div>
                        <div class="col-sm-8">
                          <input DATE="text" id="input-create-name" name="name" placeholder="Firstname"
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-create-EMAIL">Email</label>
                        </div>
                        <div class="col-sm-8">
                          <input DATE="text" id="input-create-email" name="EMAIL" placeholder="Email"
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <label class="col-form-label col-sm-4" for="input-create-MESSAGE">Message</label>
                        <div class="col-sm-8">
                          <input DATE="text" id="input-create-message" name="MESSAGE" placeholder="Message"
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <label class="col-form-label col-sm-4" for="input-create-date">Current Date</label>
                        <div class="col-sm-8">
                          <p DATE="text" id="input-create-date"
                            class="form-control">
                        </div>
                      </div>
                    </form>
                  </div>
                  <div class="modal-footer">
                    <button class="btn btn-primary" id="btn-create-user">Insert Contact</button>
                    <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                  </div>
                </div>
              </div>
            </div>
          </div>

          <!--Update User modal-->
          <div>
            <div id="update-user-modal" class="modal fade" tabindex="-1">
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Chi tiết Contact</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                    <form>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-update-name">Name</label>
                        </div>
                        <div class="col-sm-8">
                          <input DATE="text" id="input-update-name" name="firstname" placeholder="Name"
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-update-email">Email</label>
                        </div>
                        <div class="col-sm-8">
                          <input DATE="text" id="input-update-email" name="email" placeholder="Email"
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <label class="col-form-label col-sm-4" for="input-update-message">Message</label>
                        <div class="col-sm-8">
                          <input DATE="text" id="input-update-message" name="MESSAGE" placeholder="Message"
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <label class="col-form-label col-sm-4" for="input-update-create-datedate">Message</label>
                        <div class="col-sm-8">
                          <input DATE="text" id="input-update-create-date" name="createDate" placeholder="Message"
                            class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <label class="col-form-label col-sm-4" for="input-update-date">Current Date</label>
                        <div class="col-sm-8">
                          <p DATE="text" id="input-update-date"
                            class="form-control">
                        </div>
                      </div>
                    </form>
                  </div>
                  <div class="modal-footer">
                    <button class="btn btn-primary" id="btn-update-user">Update Contact</button>
                    <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- Delete confirm modal -->
          <div>
            <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Contact Delete Confirmation</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                    <label>Bạn có chắc chắn muốn xóa contact này không?</label>
                  </div>
                  <div class="modal-footer">
                    <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                    <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                  </div>
                </div>
              </div>
            </div>
          </div>

        </section>
        <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block">
          <b>Version</b> 3.2.0
        </div>
        <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
      </footer>

      <!-- Control Sidebar -->
      <aside class="control-sidebar control-sidebar-dark">
        <!-- Control sidebar content goes here -->
      </aside>
      <!-- /.control-sidebar -->
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- Bootstrap Switch -->
    <script src="plugins/bootstrap-switch/js/bootstrap-switch.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <script src="plugins/datatables/jquery.dataTables.js"></script>
    <script>
      "use strict";
      /*** REGION 1 - Global Variables */
      const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
      //Biến toàn cục để lưu trữ id user đang được update or delete. Mặc định = 0;
      var gUserId = 0;
      
      // Biến mảng hằng số chứa danh sách tên các thuộc tính
      const gUSER_COLS = ["id", "name", "email", "message", "createDate", "action"];

      //Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
      const gUSER_ID_COL = 0;
      const gUSER_NAME_COL = 1;
      const gUSER_EMAIL_COL = 2;
      const gUSER_MESSAGE_COL = 3;
      const gUSER_CREATE_DATE_COL = 4;
      const gUSER_ACTION_COL = 5;

      // Khai báo DataTable & Mapping column
      var gUserTable = $("#user-table").DataTable({
        columns: [
          { data: gUSER_COLS[gUSER_ID_COL] },
          { data: gUSER_COLS[gUSER_NAME_COL] },
          { data: gUSER_COLS[gUSER_EMAIL_COL] },
          { data: gUSER_COLS[gUSER_MESSAGE_COL] },
          { data: gUSER_COLS[gUSER_CREATE_DATE_COL] },
          { data: gUSER_COLS[gUSER_ACTION_COL] }
        ],
        columnDefs: [
          { // định nghĩa các cột action
            targets: gUSER_ACTION_COL,
            defaultContent: `
                    <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `
          }
        ]
      });

      //hàm gọi ngày hôm nay
      var dt = new Date();
      document.getElementById('input-create-date').innerHTML=dt;
      document.getElementById('input-update-date').innerHTML=dt;

      /*** REGION 2 - Vùng gán/  thực thi sự kiện cho các element */
      $(document).ready(function () {
        onPageLoading();
      });
      // gán sự kiện Create - them 1 user
      $("#btn-add-user").on("click", function () {
        onBtnAddNewUserClick();
      });
      // gán sự kiện Update - sửa 1 user
      $("#user-table").on("click", ".edit-user", function () {
        onBtnEditUserClick(this);
      });
      // gán sự kiện Delete - xoa 1 user
      $("#user-table").on("click", ".delete-user", function () {
        onBtnDeleteUserClick(this);
      });

      // gán sự kiện Inser User - them 1 user tren modal
      $("#btn-create-user").on("click", function () {
        onBtnCreateUserClick();
      });

      // gán sự kiện cho nút Update User (trên modal)
      $("#btn-update-user").on("click", function () {
        onBtnUpdateUserClick();
      });

      // gán sự kiện cho nút Confirm Delete User (trên modal)
      $("#btn-confirm-delete-user").on("click", function () {
        onBtnConfirmDeleteUserClick();
      });

      /*** REGION 3 - Event handlers */
      function onPageLoading() {
        //B1: Thu thap du lieu
        getAllUsers();
      }
      // Hàm xử lý sự kiện khi New User được click
      function onBtnAddNewUserClick() {
        //hiển thị modal trắng lên
        $("#create-user-modal").modal("show");
      }
      // Hàm xử lý sự kiện khi Insert User được click
      function onBtnCreateUserClick() {
        //khai báo đối tượng chứa user data
        var vObjectRequestData = {
          name: "",
          email: "",
          message: "",
          createDate: ""
        };
        //B1: thu thap du lieu
        getInsertUserData(vObjectRequestData);
        //B2: Validate Insert
        var vIsValidate = validateUserData(vObjectRequestData);
        //ghi ra console giá trị trả ra của hàm validateUserData
        console.log(vIsValidate);
        //B3: Insert User
        $.ajax({
          url: gBASE_URL + "/contacts",
          DATE: "POST",
          contentDATE: "application/json;charset=UTF-8",
          data: JSON.stringify(vObjectRequestData),
          success: function (paramRes) {
            //Ghi response ra console
            console.log(paramRes);
            //B4: front-end 
            handleInsertUserSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status)
          }
        });
      }
      // Hàm xử lý sự kiện khi icon edit user trên bảng được click
      function onBtnEditUserClick(paramBtnEdit) {
        //lưu thông tin userId đang được edit vào biến toàn cục
        gUserId = getUserIdFromButton(paramBtnEdit);
        console.log("Id = " + gUserId);
        //hiển thị modal trắng lên
        $("#update-user-modal").modal("show");
        // load dữ liệu vào các trường dữ liệu trong modal
        getUserById(gUserId);
      }
      // hàm xử lý sự kiện update user modal click
      function onBtnUpdateUserClick() {
        // khai báo đối tượng chứa user data
        var vUserObj = {
          name: "",
          email: "",
          message: "",
          createDate: "",
        };
        // B1: Thu thập dữ liệu
        getUpdateUserData(vUserObj);
        // B2: Validate update
        var vIsUserValidate = validateUserData(vUserObj);
        if (vIsUserValidate) {
          // B3: update user
          $.ajax({
            url: gBASE_URL + "/contacts/" + gUserId,
            DATE: "PUT",
            contentDATE: "application/json;charset=UTF-8",
            data: JSON.stringify(vUserObj),
            success: function (paramRes) {
              // B4: xử lý front-end
              handleUpdateUserSuccess();
            },
            error: function (paramErr) {
              console.log(paramErr.status);
            }
          });
        }
      }

      // Hàm xử lý sự kiện khi icon delete user trên bảng được click
      function onBtnDeleteUserClick(paramBtnDelete) {
        //lưu thông tin userId đang được xoa vào biến toàn cục
        gUserId = getUserIdFromButton(paramBtnDelete);
        console.log("Id = " + gUserId);
        // hiển thị modal confirm delete lên
        $("#delete-confirm-modal").modal("show");
      }
      // // Hàm xử lý sự kiện khi nút confirm delete user trên modal được click
      function onBtnConfirmDeleteUserClick() {
        $.ajax({
          url: gBASE_URL + "/contacts/" + gUserId,
          DATE: "DELETE",
          success: function (paramRes) {
            // B4: xử lý front-end
            handleDeleteUserSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
      /*** REGION 4 - Common Functions */
      /** load users to Datatable
       * in: users array
       * out: user table has data
       */
      function loadDataToUserTable(paramUsers) {
        gUserTable.clear();
        gUserTable.rows.add(paramUsers);
        gUserTable.draw();
      }
      //hàm gọi api để lấy danh sách all user đăng ký
      function getAllUsers() {
        $.ajax({
          url: gBASE_URL + "/contacts/",
          DATE: "GET",
          success: function (paramUsers) {
            // Ghi Response ra console
            console.log(paramUsers);
            loadDataToUserTable(paramUsers);
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
      // hàm get user by id
      function getUserById(paramUserId) {
        $.ajax({
          url: gBASE_URL + "/contacts/" + paramUserId,
          DATE: "GET",
          success: function (paramUser) {
            showUserDataToModal(paramUser);
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }

      // hàm show user obj lên modal
      function showUserDataToModal(paramUser) {
        $("#input-update-name").val(paramUser.name);
        $("#input-update-email").val(paramUser.email);
        $("#input-update-message").val(paramUser.message);
        $("#input-update-create-date").val(paramUser.createDate);
      }

      // hàm dựa vào button detail (edit or delete) xác định được id user
      function getUserIdFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vUserRowData = gUserTable.row(vTableRow).data();
        return vUserRowData.id;
      }

      //hàm thu thâpj dữ liệu để create user
      function getInsertUserData(paramUserObj) {
        paramUserObj.name = $("#input-create-name").val().trim();
        paramUserObj.email = $("#input-create-email").val().trim();
        paramUserObj.message = $("#input-create-message").val().trim();
      }

      // hàm validate data
      function validateUserData(paramUserObj) {
        if (paramUserObj.name === "") {
          alert("Enter firstname!");
          return false;
        }

        if (paramUserObj.email === "") {
          alert("Enter EMAIL!");
          return false;
        }

        if (paramUserObj.message === "") {
          alert("Enter MESSAGE!");
          return false;
        }
        return true;
      }

      // xử lý front-end khi thêm user thành công
      //Khi người dùng ấn OK trên cửa sổ thông báo Alert: xóa trắng dữ liệu trên modal, tắt Modal đi và load lại bảng danh sách users
      function handleInsertUserSuccess() {
        alert("Add contact successful!");
        getAllUsers();
        resertCreateUserForm();
        $("#create-user-modal").modal("hide");
      }

      //hàm xóa trắng form create user
      function resertCreateUserForm() {
        $("#input-create-name").val("");
        $("#input-create-email").val("");
        $("#input-create-message").val("");
      }

      // hàm thu thập dữ liệu để update user
      function getUpdateUserData(paramUserObj) {
        paramUserObj.name = $("#input-update-name").val().trim();
        paramUserObj.email = $("#input-update-email").val().trim();
        paramUserObj.message = $("#input-update-message").val().trim();
      }

      // hàm xử lý hiển thị front-end khi sửa user thành công
      function handleUpdateUserSuccess() {
        alert("Sửa contact thành công!");
        getAllUsers();
        resertUpdateUserForm();
        $("#update-user-modal").modal("hide");
      }

      // hàm xóa trắng form update user
      function resertUpdateUserForm() {
        $("#input-update-name").val("");
        $("#input-update-email").val("");
        $("#input-update-message").val("");
      }

      // hàm xử lý hiển thị front-end khi xoa user thành công
      function handleDeleteUserSuccess() {
        alert("Delete contact thành công!");
        getAllUsers();
        $("#delete-user-modal").modal("hide");
      }
    </script>
  </body>

  </html>